import es, popuplib, random, gamethread, math
from dnds import *
info = es.AddonInfo()
info.name = 'D&DSource Mod - PVKII'
info.version = '0.0.3 Python'
info.url = 'http://addons.eventscripts.com/addons/view/dnds'
info.basename = 'pvkiidnds'
info.author = 'J3ff Hoogland'
#Begin Events
#Local Events
def est_client_keypress(ev):
    userid = int(ev['userid'])
    if ev['key'] == 'walk' or ev['key'] == 'duck':
        if ev['status'] == '1':
            StealthOn(userid)
        else:
            StealthOff(userid)
def player_spawn(ev):
    userid = int(ev['userid'])
    Character = dnds.getPlayer(userid)['Character']
    Playerlib = dnds.getPlayer(userid)['playerlib']
    Player = dnds.getPlayer(userid)['Player']
    for x in default_keys:
        Player.key[x] = 0
    if len(Character.key['classes']):
        Class = Character.key['classes'].keys()[0]
    else:
        Class = None
    if Class:
        Playerlib.set('speed', dnds.Classes[Class]['speed'])
        Player.key['healing surges'] = dnds.Classes[Class]['healing surges']+dnds.statMod(userid, 'Constitution')
        if 'Durable' in Character.key['feats']:
            Player.key['healing surges'] += 2
        if 'Fase Runner' in Character.key['feats']:
            Playerlib.set('speed', Playerlib.get('speed')+.1)
        if 'Light Step' in Character.key['feats']:
            Playerlib.set('speed', Playerlib.get('speed')+.1)
        if 'Long Jumper' in Character.key['feats']:
            Player.key['long jump'] += .2
        es.setplayerprop(userid, 'CPVK2Player.m_iMaxHealth', dnds.Classes[Class]['health']+(Character.key['abilities']['Constitution']*10))
        if 'Toughness' in Character.key['feats']:
            es.setplayerprop(userid, 'CPVK2Player.m_iMaxHealth', int(es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth'))+30)
        dnds.report('PVKII - %s Max Health %s'%(es.getplayername(userid), es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth')))
        gamethread.delayed(.25, es.setplayerprop, (userid, 'CBasePlayer.m_iHealth', es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth')))
        es.setplayerprop(userid, 'CPVK2Player.m_iMaxArmor', dnds.Classes[Class]['armor'])
        gamethread.delayed(.25, es.setplayerprop, (userid, 'CPVK2Player.m_ArmorValue', es.getplayerprop(userid,'CPVK2Player.m_iMaxArmor')))
        dnds.report('PVKII - %s Max Armor %s'%(es.getplayername(userid),dnds.Classes[Class]['armor']))
        Playerlib.set('model', dnds.Classes[Class]['model'])
        es.server.queuecmd('est_stripplayer %s'%userid)
        for x in dnds.Classes[Class]['weapons']:
            es.server.queuecmd('es_xdelayed .5 es_xgive %s %s'%(userid, x))
        if Class == 'Ranger':
            if Character.key['weapon type'] == 'two weapon':
                es.server.queuecmd('es_xdelayed .5 es_xgive %s weapon_axesword'%userid)
                es.server.queuecmd('es_xdelayed .5 es_xgive %s weapon_throwaxe'%userid)
            elif Character.keyp['weapon type'] == 'archer':
                es.server.queuecmd('es_xdelayed .5 es_xgive %s weapon_longbow'%userid)
        for x in dnds.Classes[Class]['ammo']:
            gamethread.delayed(.25, es.setplayerprop, (userid, 'CBasePlayer.localdata.m_iAmmo.%s'%x, dnds.Classes[Class]['ammo'][x]))
def player_damage(ev):
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    damage = int(ev['dmg_health'])
    PlayerHurt(userid, attacker, damage, ev['weapon'], dnds.getPlayer(userid)['Character'].key['classes'].keys(), dnds.getPlayer(userid)['Character'])
    if attacker:
        PlayerHit(attacker, userid, damage, ev['weapon'], dnds.getPlayer(attacker)['Character'].key['classes'].keys(), dnds.getPlayer(attacker)['Character'])
#End Local Events
#Global Events
#End Global Events
#End Events
#Commands Methods
#Warlocks blast command
def blastcmd():
    userid = int(es.getcmduserid())
    if 'Warlock' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
        level = dnds.getPlayer(userid)['Character'].key['classes']['Warlock']['level']
        if level >= 1:
            if not dnds.getPlayer(userid)['Player'].key['blast used']:
                es.ServerVar('_dnds_temp').set(0)
                es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                gamethread.delayed(.1, blastRun, (userid))
            else:
                es.tell(userid, '#multi', dnds.text('blastcmd 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('blastcmd 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('blastcmd 3',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def blastRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 600:
            dnds.getPlayer(userid)['Player'].key['blast used'] = 1
            dnds.getPlayer(userid)['Player'].Delayed(4, blastWipe, userid)
            if dnds.getPlayer(userid)['Character'].key['abilities']['Constitution'] > dnds.getPlayer(userid)['Character'].key['abilities']['Charisma']:
                stat = 'Constitution'
            else:
                stat = 'Charisma'
            dnds.getPlayer(target)['Player'].Damage(random.randint(3, 30)+dnds.statMod(userid, stat)*2, userid, 1)
        else:
            es.tell(userid, '#multi', dnds.text('blastRun 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def blastWipe(userid):
    dnds.getPlayer(userid)['Player'].key['blast used'] = 0
#Ranger's wolv command
def wolvcmd():
    userid = int(es.getcmduserid())
    if 'Ranger' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
        level = dnds.getPlayer(userid)['Character'].key['classes']['Ranger']['level']
        if level >= 3:
            if not dnds.getPlayer(userid)['Player'].key['wolv used']:
                flist, olist = dnds.getPlayer(userid)['Player'].NearList(60)
                dnds.getPlayer(userid)['Player'].key['wolv used'] = 1
                dnds.getPlayer(userid)['Player'].Delayed(15, wolvWipe, userid)
                for id in olist:
                    dnds.getPlayer(id)['Player'].Damage(random.randint(13,27),userid)
            else:
                es.tell(userid, '#multi', dnds.text('wolvcmd 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('wolvcmd 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('wolvcmd 3',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def wolvWipe(userid):
    dnds.getPlayer(userid)['Player'].key['wolv used'] = 0
    es.tell(userid, '#multi', dnds.text('wolvWipe 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Paladin's hands command
def handscmd():
    userid = int(es.getcmduserid())
    if 'Paladin' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
        level = dnds.getPlayer(userid)['Character'].key['classes']['Paladin']['level']
        if level >= 2:
            es.ServerVar('_dnds_temp').set(0)
            es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
            gamethread.delayed(.1, handsRun, (userid))
        else:
            es.tell(userid, '#multi', dnds.text('handscmd 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('handscmd 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def handsRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 20:
            HealingSurge(target, userid)
            if 'Healing Hands' in dnds.getPlayer(userid)['Character'].key['feats']:
                Heal(target, dnds.getPlayer(userid)['Character'].key['abilities']['Charisma'])
                es.tell(userid, '#multi', dnds.text('handsRun 1',{'name':es.getplayername(target),'amount':dnds.getPlayer(userid)['Character'].key['abilities']['Charisma']},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('handsRun 2',{'name':es.getplayername(target)},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('handsRun 3',{'name':es.getplayername(target)},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Cleric's word command
def wordcmd():
    #es.msg('wordcmd')
    userid = int(es.getcmduserid())
    dnds.report('%s ran the wordcmd in chat/console'%es.getplayername(userid))
    if not dnds.getPlayer(userid)['Player'].key['word used']:
        if 'Cleric' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Cleric']['level']
            if level >= 1:
                es.ServerVar('_dnds_temp').set(0)
                es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                gamethread.delayed(.1, wordRun, (userid))
            else:
                es.tell(userid, '#multi', dnds.text('wordcmd 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('wordcmd 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('wordcmd 3',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def wordRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    #es.msg('Target = %s'%target)
    #es.msg('Word Run')
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        level = dnds.getPlayer(userid)['Character'].key['classes']['Cleric']['level']
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 115+(level*5):
            dnds.getPlayer(userid)['Player'].key['word used'] = 1
            gamethread.delayed(15, wordWipe, (userid))
            HealingSurge(target)
            if level < 6:
                amount = random.randint(1, 6)
            elif level < 11:
                amount = random.randint(2, 12)
            elif level < 16:
                amount = random.randint(3, 18)
            elif level < 21:
                amount = random.randint(4, 24)
            elif level < 26:
                amount = random.randint(5, 30)
            else:
                amount = random.randint(6, 36)
            Heal(target, amount)
            es.tell(userid, '#multi', dnds.text('wordRun 1',{'name':es.getplayername(target),'amount':amount},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('wordRun 2',{'name':es.getplayername(target)},dnds.getPlayer(userid)['playerlib'].get('lang')))
def wordWipe(userid):
    dnds.getPlayer(userid)['Player'].key['word used'] = 0
    es.tell(userid, '#multi', dnds.text('wordWipe 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Cleric's glow command
def glowcmd():
    userid = int(es.getcmduserid())
    dnds.report('%s ran the glowcmd in chat/console'%es.getplayername(userid))
    if not dnds.getPlayer(userid)['Player'].key['glow used']:
        if 'Cleric' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Cleric']['level']
            if level >= 5:
                dnds.getPlayer(userid)['Player'].key['glow used'] = 1
                dnds.getPlayer(userid)['Player'].Delayed(15, glowSelf, userid)
                flist, olist = dnds.getPlayer(userid)['Player'].NearList(240)
                team = es.getplayerteam(userid)
                for id in olist:
                    dnds.getPlayer(id)['Player'].Damage(random.randint(14,33),userid)
                for id in flist:
                    dnds.getPlayer(id)['Player'].key['glowing'] = 1
                    dnds.getPlayer(id)['Player'].Delayed(6, glowAlly, id)
            else:
                es.tell(userid, '#multi', dnds.text('glowcmd 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('glowcmd 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('glowcmd 3',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def glowSelf(userid):
    dnds.getPlayer(userid)['Player'].key['glow used'] = 0
    es.tell(userid, '#multi', dnds.text('glowSelf 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def glowAlly(id):
    dnds.getPlayer(id)['Player'].key['glowing'] = 0
#Controls the rogue's stealth as he toggles it with his walk key on/off
def StealthOn(userid):
    if 'Rogue' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
        if not dnds.getPlayer(userid)['Player'].key['stealth delay'] and not dnds.getPlayer(userid)['Player'].key['stealthed']:
            dnds.getPlayer(userid)['Player'].key['stealthed'] = 1
            es.server.queuecmd('est_setplayercolor %s 255 255 255 %s 1'%(userid, 75-dnds.statMod(userid, 'Dexterity')*7))
def StealthOff(userid):
    if 'Rogue' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
        es.server.queuecmd('est_setplayercolor %s 255 255 255 255 1'%userid)
        dnds.getPlayer(userid)['Player'].key['stealthed'] = 0
def StealthDown(userid):
    es.server.queuecmd('est_setplayercolor %s 255 255 255 255 1'%userid)
    if dnds.getPlayer(userid)['Player'].key['stealthed']:
        es.tell(userid, '#multi', dnds.text('pvkii StealthDown 1',{},dnds.getPlayer(userid).get('lang')))
        dnds.getPlayer(userid)['Player'].key['stealthed'] = 0
    dnds.getPlayer(userid)['Player'].key['stealth delay'] += 1
    dnds.getPlayer(userid)['Player'].Delayed(3, StealthReset, userid)
def StealthReset(userid):
    dnds.getPlayer(userid)['Player'].key['stealth delay'] -= 1
#Begin +wind and -wind
def WindOn():
    userid = int(es.getcmduserid())
    if es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth') != es.getplayerprop(userid, 'CBasePlayer.m_iHealth'):
        if not dnds.getPlayer(userid)['Player'].key['wind used']:
            if dnds.getPlayer(userid)['Player'].key['healing surges']:
                dnds.getPlayer(userid)['Player'].key['wind on'] = 1
                dnds.getPlayer(userid)['Player'].Delayed(1, WindLoop, (userid, 1))
                dnds.getPlayer(userid)['Player'].Freeze()
                es.tell(userid, '#multi', dnds.text('WindOn 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('WindOn 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WindOn 3',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('WindOn 4',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def WindOff():
    userid = int(es.getcmduserid())
    dnds.getPlayer(userid)['Player'].Unfreeze()
    dnds.getPlayer(userid)['Player'].key['wind on'] = 0
def WindLoop(userid, count):
    if count < 3 and dnds.getPlayer(userid)['Player'].key['wind on']:
        dnds.getPlayer(userid)['Player'].Delayed(1, WindLoop, (userid, count+1))
    else:
        WindRun(userid)
def WindRun(userid):
    dnds.getPlayer(userid)['Player'].key['wind used'] = 1
    HealingSurge(userid)
    dnds.getPlayer(userid)['Player'].Unfreeze()
    dnds.getPlayer(userid)['Player'].key['wind on'] = 0
    dnds.getPlayer(userid)['Player'].Delayed(20, WindWipe, userid)
def WindWipe(userid):
    dnds.getPlayer(userid)['Player'].key['wind used'] = 0
    if dnds.getPlayer(userid)['Player'].key['healing surges']:
        es.tell(userid, '#multi', dnds.text('WindWipe 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#End Command Methods
#Global Methods
#Helps me break down events and pass in key info about users
def PlayerHurt(userid, attacker, damage, weapon, Classes, Character):
    Dead = dnds.getPlayer(userid)['playerlib'].get('isdead')
    if 'Cleric' in Classes:
        level = Character.key['classes']['Cleric']['level']
        if level >= 2:
            Heal(userid, damage/10)
    if 'Rogue' in Classes:
        level = Character.key['classes']['Rogue']['level']
        if dnds.getPlayer(userid)['Player'].key['stealthed']:
            StealthDown(userid)
        if level >= 3:
            if dnds.getPlayer(userid)['playerlib'].get('weapon') in Meele_Weapons:
                if not random.randrange(9):
                    dnds.getPlayer(attacker).Damage(random.randint(13, 37), userid)
    if 'Warlock' in Classes:
        level = Character.key['classes']['Warlock']['level']
        if level >= 2:
            if not random.randrange(9):
                dnds.getPlayer(attacker)['playerlib'].set('burn')
                gamethread.delayed(3, dnds.getPlayer(attacker)['playerlib'].set, "extinguish")
                es.tell(userid, '#multi', dnds.text('pvkii PlayerHurt 2',{'name':es.getplayername(attacker)},dnds.getPlayer(userid).get('lang')))
    dexmod = dnds.statMod(userid, 'Dexterity')*4
    intmod = dnds.statMod(userid, 'Intelligence')*4
    if not Dead:
        chance = random.randint(1, 100)
        if dexmod > intmod:
            if dexmod >= chance:
                Heal(userid, damage)
                es.tell(userid, '#multi', dnds.text('pvkii PlayerHurt 1',{'damage':damage,'stat':'Dexterity'},dnds.getPlayer(userid).get('lang')))
        else:
            if intmod >= chance:
                Heal(userid, damage)
                es.tell(userid, '#multi', dnds.text('pvkii PlayerHurt 1',{'damage':damage,'stat':'Intelligence'},dnds.getPlayer(userid).get('lang')))
def PlayerHit(userid, victim, damage, weapon, Classes, Character):
    MeeleBuff = 1
    if 'Cleric' in Classes:
        level = Character.key['classes']['Cleric']['level']
        if level >= 3:
            if not random.randrange(5):
                dnds.getPlayer(victim)['Player'].Damage(damage*.2,userid)
                if not random.randrange(3):
                    dnds.getPlayer(victim)['playerlib'].set('burn')
                    gamethread.delayed(3, dnds.getPlayer(victim)['playerlib'].set, "extinguish")
    if 'Fighter' in Classes:
        level = Character.key['classes']['Fighter']['level']
        if level >= 1:
            if weapon in Meele_Weapons:
                flist, olist = dnds.getPlayer(userid)['Player'].NearList(20)
                if len(olist):
                    id = random.choice(olist)
                else:
                    id = None
                if id:
                    dnds.getPlayer(id)['Player'].Damage(damage*(.5*dnds.statMod(userid, 'Strength')),userid)
        if level >= 2:
            if weapon in Meele_Weapons:
                if not random.randrange(4):
                    x,y,z = es.getplayerlocation(userid)
                    es.server.queuecmd('est_pushto %s %s %s %s -10'%(victim,x,y,z))
                    es.tell(userid, '#multi', dnds.text('pvkii PlayerHit 1',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
        if level >= 3:
            if weapon in Meele_Weapons:
                if not random.randrange(19):
                    dnds.getPlayer(userid)['playerlib'].set('speed', dnds.getPlayer(userid)['playerlib'].get('speed')-.2)
                    es.tell(userid, '#multi', dnds.text('pvkii PlayerHit 2',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
        if level >= 5:
            if weapon in Meele_Weapons:
                if int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) < int(es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth'))/2:
                    if not random.randrange(9):
                        if dnds.getPlayer(userid)['Player'].key['healing surges']:
                            es.tell(userid, '#multi', dnds.text('pvkii PlayerHit 3',{},dnds.getPlayer(userid).get('lang')))
                            HealingSurge(userid)
    if 'Paladin' in Classes:
        level = Character.key['classes']['Paladin']['level']
        if level >= 1:
            if weapon in Meele_Weapons:
                dnds.getPlayer(victim)['Player'].Damage(damage*(.5*dnds.statMod(userid, 'Strength')),userid)
        if level >= 3:
            if weapon in Meele_Weapons:
                dnds.getPlayer(victim)['Player'].Damage(damage*(.5*dnds.statMod(userid, 'Wisdom')),userid)
        if level >= 5:
            if weapon in Meele_Weapons:
                if not random.randrange(5):
                    es.tell(userid, '#multi', dnds.text('pvkii PlayerHit 4',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
                    dnds.getPlayer(victim)['Player'].Freeze(1)
    if 'Rogue' in Classes:
        level = Character.key['classes']['Rogue']['level']
        if level >= 1:
            if dnds.getPlayer(userid)['Player'].key['stealthed']:
                if 'Backstabber' in Character.key['feats']:
                    range = 8
                else:
                    range = 6
                if level < 10:
                    dice = 4
                elif level < 20:
                    dice = 6
                else:
                    dice = 10
                amount = 0
                while dice > 0:
                    dice -= 1
                    amount += random.randint(1, range)
                dnds.getPlayer(victim)['Player'].Damage(amount,userid)
                es.tell(userid, '#multi', dnds.text('pvkii PlayerHit 5',{'name':es.getplayername(victim),'amount':amount},dnds.getPlayer(userid).get('lang')))
        if level >= 2:
            MeeleBuff = 0
            dnds.getPlayer(victim)['Player'].Damage(damage*(.5*dnds.statMod(userid, 'Dexterity')),userid)
        if level >= 5:
            if weapon in Meele_Weapons:
                if not random.randrange(19):
                    dnds.getPlayer(victim)['Player'].Damage(damage, userid)
                    es.tell(userid, '#multi', dnds.text('pvkii PlayerHit 6',{'amount':damage},dnds.getPlayer(userid).get('lang')))
        StealthDown(userid)
    if 'Ranger' in Classes:
        level = Character.key['classes']['Ranger']['level']
        type = Character.key['weapon type']
        if level >= 2:
            if not random.randrange(19):
                bonus = random.randint(13, 27)
                dnds.getPlayer(victim)['Player'].Damage(bonus,userid)
                es.tell(userid, '#multi', dnds.text('pvkii PlayerHit 7',{'amount':bonus},dnds.getPlayer(userid).get('lang')))
        if level >= 5:
            if not random.randrange(19):
                es.tell(userid, '#multi', dnds.text('pvkii PlayerHit 8',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
                dnds.getPlayer(victim)['playerlib'].set('speed', dnds.getPlayer(victim)['playerlib'].get('speed')-.2)
                dnds.getPlayer(victim)['Player'].Delayed(4, dnds.getPlayer(victim)['playerlib'].set, ('speed', dnds.getPlayer(userid)['playerlib'].get('speed')+.2))
        if type == 'archer':
            if level >= 1:
                if weapon in Ranged_Weapons:
                    dnds.getPlayer(victim)['Player'].Damage(damage*(.5*dnds.statMod(userid, 'Dexterity')),userid)
            if level >= 3:
                if weapon in Ranged_Weapons:
                    dnds.getPlayer(victim)['Player'].Damage(damage*(.5*dnds.statMod(userid, 'Wisdom')),userid)
        if type == 'two weapon':
            if level >= 1:
                if weapon in Meele_Weapons:
                    dnds.getPlayer(userid)['playerlib'].set('speed', dnds.getPlayer(userid)['playerlib'].get('speed')+.15)
                    dnds.getPlayer(userid)['Player'].Delayed(1.75, dnds.getPlayer(userid)['playerlib'].set, ('speed', dnds.getPlayer(userid)['playerlib'].get('speed')-.15))
    if 'Power Attack' in Character.key['feats']:
        if weapon in Meele_Weapons:
            dnds.getPlayer(victim)['Player'].Damage(damage*.1,userid)
    if 'Dwarven Weapon Training' in Character.key['feats']:
        if weapon in Axes:
            dnds.getPlayer(victim)['Player'].Damage(damage*.15,userid)
    if 'Eladrin Soldier' in Character.key['feats']:
        if weapon in Swords:
            dnds.getPlayer(victim)['Player'].Damage(damage*.1,userid)
    if weapon in Meele_Weapons and MeeleBuff:
        dnds.getPlayer(victim)['Player'].Damage(damage*(.5*dnds.statMod(userid, 'Strength')),userid)
    if dnds.getPlayer(userid)['Player'].key['glowing']:
        dnds.getPlayer(victim)['Player'].Damage(damage*.1,userid)
#Some core commands we use
def HealingSurge(userid, user=None):
    if not user:
        hs = dnds.getPlayer(userid)['Player'].key['healing surges']
    else:
        hs = dnds.getPlayer(user)['Player'].key['healing surges']
    if hs:
        if es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth') != es.getplayerprop(userid, 'CBasePlayer.m_iHealth'):
            Character = dnds.getPlayer(userid)['Character']
            Class = Character.key['classes'].keys()[0]
            Surge = ((dnds.Classes[Class]['health']+(Character.key['abilities']['Constitution']*10))/2)/2
            Heal(userid, Surge)
            if not user:
                dnds.getPlayer(userid)['Player'].key['healing surges'] -= 1
            else:
                dnds.getPlayer(user)['Player'].key['healing surges'] -= 1
            es.tell(userid, '#multi', dnds.text('HealingSurge 1',{'surge':Surge,'remaining':dnds.getPlayer(userid)['Player'].key['healing surges']},dnds.getPlayer(userid)['playerlib'].get('lang')))
def Heal(userid, amount):
    if not dnds.getPlayer(userid)['playerlib'].get('isdead'):
        Health = int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))
        MaxHealth = int(es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth'))
        if (Health+amount) <= MaxHealth:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', Health+amount)
        else:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', MaxHealth)
#End Global Methods
#Load and Unload Methods
def load():
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII Begin Load')
    for x in dnds.Class_List:
        for i in range(1, 5):
            dnds.Classes[x]['info'].append('pvkii %s %s'%(x, i))
        for i in range(1, 5):
            if x != 'Ranger':
                dnds.Classes[x]['powers1'].append('pvkii %s Powers1 %s'%(x, i))
            elif x == 'Ranger':
                dnds.Classes[x]['powers1'].append('pvkii %s Archer Powers1 %s'%(x, i))
                dnds.Classes[x]['powers1'].append('pvkii %s Two Weapon Powers1 %s'%(x, i))
        if x == 'Rogue':
            dnds.Classes[x]['info'].append('pvkii %s 5'%(x))
        for y in ClassSet[x]:
            dnds.Classes[x][y] = ClassSet[x][y]
    for i in range(1, 3):
        dnds.Abilities['Constitution']['info'].append('pvkii Constitution %s'%i)
    for a in ['Strength','Dexterity','Intelligence']:
        dnds.Abilities[a]['info'].append('pvkii %s 1'%a)
    for f in dnds.Feat_List:
        dnds.Feats[f]['info'].append('pvkii %s 1'%f)
    if not es.exists('clientcommand','+wind'):
        es.regclientcmd('+wind','dnds/games/pvkiidnds/WindOn')
    if not es.exists('clientcommand','-wind'):
        es.regclientcmd('-wind','dnds/games/pvkiidnds/WindOff')
    for x in ['word','glow','hands','wolv','blast']:
        #es.msg('Found %s Command for PVKIIDNDS'%x)
        if not es.exists('clientcommand', x):
            #es.msg('Reging %s as a client command'%x)
            es.regclientcmd(x, 'dnds/games/pvkiidnds/%scmd'%x)
        #else:
            #es.msg('%s is already client command'%x)
        if not es.exists('saycommand', x):
            #es.msg('Reging %s as a Client Say command'%x)
            es.regsaycmd(x, 'dnds/games/pvkiidnds/%scmd'%x)
        #else:
            #es.msg('%s is already client say command'%x)
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII End Load')
def unload():
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII Unload Start')
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII Unload End')
Meele_Weapons = ['twosword','swordshield','archersword','cutlass','cutlass2','hook','bigaxe','axesword','twoaxe','vikingshield']
Ranged_Weapons = ['crossbow','longbow','flintlock','blunderbuss','throwaxe']
Swords = ['twosword','swordshield','archersword','cutlass','cutlass2','axesword','vikingshield']
Axes = ['bigaxe','axesword','twoaxe','throwaxe']
Special_Weapons = ['powderkeg','parrot']
default_keys = ['wind used','word used','glow used','glowing','stealth delay','stealthed','wolv used','blast used']
ClassSet = {'Cleric':   {'health':120,
                        'armor':120,
                        'model':'player/heavyknight/heavyknight',
                        'weapons': ['weapon_twoaxe','weapon_vikingshield'],
                        'ammo':{},
                        'healing surges':7,
                        'speed':1.0},
            'Fighter':  {'health':150,
                        'armor':150,
                        'model':'player/berserker/berserker',
                        'weapons':['weapon_bigaxe','weapon_crossbow','weapon_throwaxe'],
                        'ammo':{'004':10,'007':5},
                        'healing surges':9,
                        'speed':1.0},
            'Paladin':  {'health':150,
                        'armor':150,
                        'model':'player/heavyknight/heavyknight',
                        'weapons':['weapon_twosword','weapon_blunderbuss'],
                        'ammo':{'006':6},
                        'healing surges':10,
                        'speed':1.0},
            'Ranger':   {'health':120,
                        'armor':100,
                        'model':'player/huscarl/huscarl',
                        'weapons':['weapon_cutlass2'],
                        'ammo':{'005':30,'007':8},
                        'healing surges':6,
                        'speed':1.0},
            'Rogue':    {'health':120,
                        'armor':80,
                        'model':'player/skirmisher/skirmisher',
                        'weapons':['weapon_cutlass','weapon_flintlock'],
                        'ammo':{'003':15},
                        'healing surges':6,
                        'speed':1.0},
            'Warlock':  {'health':120,
                        'armor':80,
                        'model':'player/bowman/bowman',
                        'weapons':['weapon_archersword','weapon_crossbow'],
                        'ammo':{'004':4},
                        'healing surges':6,
                        'speed':1.0},
            'Warlord':  {'health':120,
                        'armor':120,
                        'model':'player/berserker/berserker',
                        'weapons':['weapon_twosword','weapon_swordshield','weapon_longbow'],
                        'ammo':{'005':15},
                        'healing surges':7,
                        'speed':1.0},
            'Wizard':   {'health':100,
                        'armor':40,
                        'model':'player/captain/captain',
                        'weapons':['weapon_archersword'],
                        'ammo':{},
                        'healing surges':6,
                        'speed':1.0}}
#End Load Methods